### CopyBelowMaterials.rb
### by Chanz - Based on DropVertices by TIG
require 'sketchup.rb'
###
module DAN
###
def self.copymaterials()

  model=Sketchup.active_model
  ents=model.active_entities
  
  faces = ents.grep(Sketchup::Face)

  faces.each {|x| 
  
    rayt=model.raytest(x.bounds.center, Z_AXIS.reverse)
	if(rayt)

		rayt[1].each{|entity|
		
		if entity.class == Sketchup::Face
				x.material = entity.material
		end
		}
	end
  }
  
  model.commit_operation

  
  begin
    model.start_operation("DAN.copymaterials", true)
  rescue
    model.start_operation("DAN.copymaterials")
  end
end
###
### menu
unless file_loaded?(File.basename(__FILE__)) 
  menu=UI.menu("Plugins").add_submenu("Copy Materials...")
  menu.add_item("To Nearest Below"){DAN.copymaterials()}
end
file_loaded(File.basename(__FILE__)) 

end
